package jadex.adapter.jade;

import jade.lang.acl.MessageTemplate;
import jade.lang.acl.ACLMessage;
import jadex.util.SReflect;

/**
 *  Match the beginning of the content.
 */
public class MatchStartContentLiteral implements MessageTemplate.MatchExpression
{
	//-------- attributes -------

	/** The start string. */
	protected String starter;

	//-------- constrcutors --------

	/**
	 *  Create a new match start content literal.
	 *  (case-insensitiv).
	 */
	public MatchStartContentLiteral(String starter)
	{
		assert starter!=null;
		this.starter = starter.toLowerCase();
	}

	/**
	 *  Test if the content begins with some string.
	 * @param msg The message.
	 * @return True, if it begins with the string.
	 */
	public boolean match(ACLMessage msg)
	{
		assert msg!=null;
		return msg.getContent()==null? false: msg.getContent().toLowerCase().startsWith(starter);
	}

	/**
	 *  Get the string representation.
	 *  @return The string representation.
	 */
	public String toString()
	{
		return  SReflect.getInnerClassName(this.getClass());
	}
}