package jadex.adapter.jade.planlib;

import jade.content.onto.basic.Action;
import jade.core.AID;
import jade.core.Agent;
import jade.domain.FIPAAgentManagement.AMSAgentDescription;
import jade.domain.FIPAAgentManagement.FIPAManagementOntology;
import jade.domain.FIPAAgentManagement.Modify;
import jade.domain.JADEAgentManagement.JADEManagementOntology;
import jadex.adapter.fipa.AgentIdentifier;
import jadex.adapter.jade.SJade;
import jadex.runtime.IGoal;
import jadex.runtime.Plan;

/**
 *  Plan for resuming a Jadex agent on the JADE platform.
 */
public class JadeAMSResumeAgentPlan extends Plan
{
	/**
	 *  The plan body.
	 */
	public void body()
	{
		AgentIdentifier	aid	= (AgentIdentifier)getParameter("agentidentifier").getValue();
		AgentIdentifier	amsfipa	= (AgentIdentifier)getParameter("ams").getValue();
		AID	amsjade;
		
		if(amsfipa==null)
		{
			// Use local ams when not specified in goal.
			amsjade	= ((Agent)getScope().getPlatformAgent()).getAMS();
			amsfipa	= SJade.convertAIDtoFipa(amsjade);
		}
		else
		{
			amsjade	= SJade.convertAIDtoJade(amsfipa);
		}

		AMSAgentDescription desc = new AMSAgentDescription();
	    desc.setName(SJade.convertAIDtoJade(aid));
	    desc.setState(AMSAgentDescription.ACTIVE);
	    Modify mod = new Modify();
	    mod.setDescription(desc);

		Action action = new Action();
		action.setActor(amsjade);
		action.setAction(mod);
			
		IGoal	req	= createGoal("rp_initiate");
		req.getParameter("receiver").setValue(amsfipa);
		req.getParameter("action").setValue(action);
		req.getParameter("ontology").setValue(FIPAManagementOntology.NAME);
		req.getParameter("language").setValue(jade.domain.FIPANames.ContentLanguage.FIPA_SL0);
		dispatchSubgoalAndWait(req);
		
		getParameter("agentdescription").setValue(SJade.convertAMSAgentDescriptiontoFipa(desc));
	}
}
