package	jadex.adapter.jade.planlib;

import jade.content.onto.basic.Action;
import jade.core.Agent;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.Deregister;
import jade.domain.FIPAAgentManagement.FIPAManagementOntology;
import jadex.adapter.jade.SJade;
import jadex.runtime.IGoal;


/**
 *  The df deregistering plan deregisters an agent at a df.
 *  The parameters have to be specified in the goal.
 *  The result of the deregister action is stored in the goal.
 */
public class JadeDFDeregisterPlan extends	JadeDFPlan
{
	//-------- constructors --------

	/*
	 *  Create a plan for deregistering from the local df.
	 *  The parameters have to be specified in the goal.
	 */
	public JadeDFDeregisterPlan()
	{
		// When description is omitted, create empty.
		if(getAgentDescription()==null)
		{
			description	= new DFAgentDescription();
		}
		// When AID is omitted, enter self.
		if(getAgentDescription().getName()==null)
			getAgentDescription().setName(((Agent)getCapability().getPlatformAgent()).getAID());
	}

	//-------- methods --------

	/**
	 *  The plan body.
	 */
	public void body()
	{
		// Create and dispatch register goal.
		Deregister	deregister	= new Deregister();
		deregister.setDescription(getAgentDescription());
		Action action = new Action();
		action.setActor(SJade.convertAIDtoJade(getDF()));
		action.setAction(deregister);

		IGoal	req	= createGoal("rp_initiate");
		req.getParameter("receiver").setValue(getDF());
		req.getParameter("action").setValue(action);
		req.getParameter("ontology").setValue(FIPAManagementOntology.NAME);
		req.getParameter("language").setValue(jade.domain.FIPANames.ContentLanguage.FIPA_SL0);
		dispatchSubgoalAndWait(req);
	}
}


