package jadex.adapter.jade.planlib;

import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jadex.adapter.fipa.AgentDescription;
import jadex.adapter.fipa.AgentIdentifier;
import jadex.adapter.jade.SJade;
import jadex.runtime.Plan;

/**
 *  The abstract base class for all df plans.
 */
public abstract class JadeDFPlan extends Plan
{
	//-------- attributes --------

	/* The df to register with (defaults to local df). */
	private AgentIdentifier	df;

	/* The df agent description (alternatively name and type may be specified). */
	// Hack!!! Should be private.
	protected DFAgentDescription	description;

	//-------- constructors --------

	/**
	 *  Create a new df plan.
	 */
	public JadeDFPlan()
	{
		//System.out.println("Created: "+this);
		Object tmp = getParameter("df").getValue();
		if(tmp !=null)
			this.df = (AgentIdentifier)tmp;
		else
			this.df	 = new AgentIdentifier("df", true);
	}

	/**
	 *  Get the agent description.
	 *  @return The agent description.
	 */
	public DFAgentDescription getAgentDescription()
	{
		if(description==null)
		{
			AgentDescription desc = (AgentDescription)getParameter("description").getValue();
			if(desc!=null)
			{
				description = SJade.convertAgentDescriptiontoJade(desc);
			}			
		}
		return this.description;
	}

	/**
	 *  Get the agent description.
	 *  @return The agent description.
	 */
	public AgentIdentifier	getDF()
	{
		return this.df;
	}
}