package	jadex.adapter.jade.planlib.mobile;

import jade.content.onto.basic.*;
import jade.domain.FIPAAgentManagement.*;
import jade.core.Agent;
import jadex.adapter.jade.SJade;
import jadex.runtime.*;


/**
 *  The df deregistering plan deregisters an agent at a df.
 *  The parameters have to be specified in the goal.
 *  The result of the deregister action is stored in the goal.
 */
public class JadeDFDeregisterPlan extends	JadeDFPlan
{
	//-------- constructors --------

	/*
	 *  Create a plan for deregistering from the local df.
	 *  The parameters have to be specified in the goal.
	 */
	public JadeDFDeregisterPlan()
	{
		// When description is omitted, create empty.
		if(getAgentDescription()==null)
		{
			description	= new DFAgentDescription();
		}
		// When AID is ommited, enter self.
		if(getAgentDescription().getName()==null)
			getAgentDescription().setName(((Agent)getCapability().getPlatformAgent()).getAID());
	}

	//-------- methods --------

	/**
	 *  The plan body.
	 */
	public void action(IEvent event)
	{
		if(event instanceof IGoalEvent && !((IGoalEvent)event).isInfo())
		{
			// Create and dispatch register goal.
			Deregister	deregister	= new Deregister();
			deregister.setDescription(getAgentDescription());
			Action action = new Action();
			action.setActor(SJade.convertAIDtoJade(getDF()));
			action.setAction(deregister);
			
			dispatchDFRequestAndWait(action);
		}
	}
}


