package jadex.adapter.jade.planlib.mobile;

import jade.core.AID;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.FIPAManagementOntology;
import jadex.adapter.fipa.AgentDescription;
import jadex.adapter.fipa.AgentIdentifier;
import jadex.adapter.fipa.SFipa;
import jadex.adapter.jade.SJade;
import jadex.runtime.IGoal;
import jadex.runtime.MobilePlan;

/**
 *  The abstract base class for all df plans.
 */
public abstract class JadeDFPlan extends MobilePlan
{
	//-------- attributes --------

	/* The df to register with (defaults to local df). */
	private AgentIdentifier	df;

	/* The df agent description. */
	// Hack!!! Should be private.
	protected DFAgentDescription	description;

	//-------- constructors --------

	/**
	 *  Create a new df plan.
	 */
	public JadeDFPlan()
	{
		//System.out.println("Created: "+this);
		this.df = (AgentIdentifier) getParameter("df").getValue();
		if(df==null)
			this.df	 = SJade.convertAIDtoFipa(new AID("df", AID.ISLOCALNAME));
	}

	/**
	 *  Get the agent description.
	 *  @return The agent description.
	 */
	public DFAgentDescription getAgentDescription()
	{
		if(description==null)
		{
			AgentDescription	ad = (AgentDescription) getParameter("description").getValue();
			if(ad!=null)
			{
				description = SJade.convertAgentDescriptiontoJade(ad);
			}
		}
		return this.description;
	}

	/**
	 *  Get the agent description.
	 *  @return The agent description.
	 */
	public AgentIdentifier	getDF()
	{
		return this.df;
	}

	/**
	 *  Dispatch a df request goal and wait for the result.
	 *  @param action	The content of the request.
	 */
	protected IGoal	dispatchDFRequestAndWait(Object action)
	{
		IGoal	reqgoal	= createGoal("rp_initiate");
		reqgoal.getParameter("content").setValue(action);
		reqgoal.getParameter("receiver").setValue(getDF());
		reqgoal.getParameter("language").setValue(SFipa.FIPA_SL0);
		reqgoal.getParameter("ontology").setValue(FIPAManagementOntology.NAME);

		dispatchSubgoalAndWait(reqgoal);
		return reqgoal;
	}
}