package	jadex.adapter.jade.planlib.mobile;

import jade.content.onto.basic.Action;
import jade.content.onto.basic.Result;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.Search;
import jade.domain.FIPAAgentManagement.SearchConstraints;
import jadex.adapter.jade.SJade;
import jadex.runtime.IEvent;
import jadex.runtime.IGoalEvent;


/**
 *  The df search plan searches a df for agents
 *  matching a df agent description template.
 *  The parameters have to be specified in the goal.
 *  The result of the deregister action is stored in the goal.
 */
public class JadeDFSearchPlan extends JadeDFPlan
{
	//-------- attributes --------

	/** The search constraints (defaults to empty constraints). */
	protected SearchConstraints	constraints;

	//-------- constructors --------

	/**
	 *  Create a new df search plan.
	 *  The parameters have to be specified in the goal.
	 */
	public JadeDFSearchPlan()
	{
		Object constr = getParameter("constraints").getValue();
		if(constr!=null)
		{
			this.constraints = SJade.convertSearchConstraintstoJade((jadex.adapter.fipa.SearchConstraints)constr);
		}
		else
		{
			this.constraints = new SearchConstraints(); // needed???
		}
	}

	//-------- template methods --------

	/**
	 *  The body.
	 */
	public void	action(IEvent event)
	{
		if(event instanceof IGoalEvent && !((IGoalEvent)event).isInfo())
		{
			// Create and dispatch search goal.
			Search	search	= new Search();
			search.setDescription(getAgentDescription());
			search.setConstraints(constraints);
			Action action = new Action();
			action.setActor(SJade.convertAIDtoJade(getDF()));
			action.setAction(search);
	
			dispatchDFRequestAndWait(action);
		}
		else
		{
			//if(ge.getGoal().getResult() instanceof Done)
			//	System.out.println("++++++++: "+((Action)((Done)ge.getGoal().getResult()).getAction()).getAction());
			// Convert result to agent description array.
			Result res = (Result)((IGoalEvent)event).getGoal().getParameter("result").getValue();
			Object[]	items	= res.getItems().toArray();
	
			for(int i=0; i<items.length; i++)
			{
				getParameterSet("result").addValue(SJade.convertAgentDescriptiontoFipa((DFAgentDescription)items[i]));
			}
		}
	}
}

