package jadex.adapter.jade.tools.logger.gui;

import jade.util.leap.ArrayList;
import jadex.adapter.jade.tools.logger.Logger;
import jadex.util.jtable.PatternEditor;

import javax.swing.*;
import javax.swing.table.DefaultTableModel;
import java.util.Vector;

/**
 *
 */
public class FilterTablePanel extends JPanel
{

    /** holds the strings to be displayed in the column headers of our table */
    final String[] columnNames = {"Sequence", "Date/Time", "Log-Level", "Agent", "Message", "Source-Class", "Source-Method", "Thread-ID"};

    /** holds the data for visible and hidden columns **/
    final boolean[] columnVisible = {true, false, true, true, true, true, true, false};

    protected JTable table;
    protected DefaultTableModel tableModel;

    private MainWindow mainWindow;
    private MainPanel mPan;
    private PanelCanvas panCan; /* To resize and modify the scroll bars */
    private Logger myLogger;

    private LogTablePanel logTable;

    private boolean filterStatus = false;


    public FilterTablePanel(MainWindow mWnd, MainPanel mPan, Logger myLogger, LogTablePanel logTable)
    {
        super();
        this.mainWindow = mWnd;
        this.mPan = mPan;
        this.myLogger = myLogger;

        this.logTable = logTable;

        tableModel = new DefaultTableModel(columnNames, 1)
        {
            public void setValueAt(Object aValue, int row, int column)
            {
                Vector rowVector = (Vector) dataVector.elementAt(row);
                rowVector.setElementAt(aValue, column);
                fireTableCellUpdated(row, column);

                boolean isEmpty = true;
                for (int i = 0; i < getColumnCount(); i++)
                {
                    if (rowVector.elementAt(i) != null)
                    {
                        String entry = rowVector.elementAt(i).toString().trim();
                        if (entry.length() != 0)
                        {
                            isEmpty = false;
                            break;
                        }
                    }
                }
                if (isEmpty && row != getRowCount() - 1)
                {
                    removeRow(row);
                }
                else if (!isEmpty && row == getRowCount() - 1)
                {
                    addRow(new Vector(getColumnCount() - 1));
                }
            }

        };


        logTable.setFilter(tableModel.getDataVector());
        table = new JTable(tableModel);
        table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
        table.setDefaultEditor(Object.class, new PatternEditor());


    }

    public void removeAllRecords()
    {
        tableModel.getDataVector().removeAllElements();
        tableModel.addRow(new Vector(tableModel.getColumnCount() - 1));
    }


    public ArrayList getFilterList()
    {
        int rows = tableModel.getRowCount();
        int cols = tableModel.getColumnCount();

        ArrayList al = new ArrayList(rows-1);

        for (int row = 0; row < rows; row++)
        {
            StringBuffer line = new StringBuffer();
            for (int col=0; col<cols;col++) {
                line.append(tableModel.getValueAt(row,col));
                line.append(";");
            }
            al.add(line);
        }
        return al;

    }


}
