/*****************************************************************
 JADE - Java Agent DEvelopment Framework is a framework to develop
 multi-agent systems in compliance with the FIPA specifications.
 Copyright (C) 2000 CSELT S.p.A.

 GNU Lesser General Public License

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation,
 version 2.1 of the License.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the
 Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 Boston, MA  02111-1307, USA.
 *****************************************************************/


package jadex.adapter.jade.tools.logger.gui;


import jade.tools.sniffer.Sniffer;


import java.awt.event.ActionEvent;

import jadex.adapter.jade.tools.logger.Logger;
import jadex.adapter.jade.tools.logger.gui.ActionProcessor;

import javax.swing.*;

/**
 Javadoc documentation for the file
 @author Francisco Regi, Andrea Soracchi - Universita` di Parma
 <Br>
 <a href="mailto:a_soracchi@libero.it"> Andrea Soracchi(e-mail) </a>
 @version $Date: 2005-04-26 13:45:51 +0000 (Tue, 26 Apr 2005) $ $Revision: 2556 $
 */


/**
 Invokes the agent Logger to display preload list.
 * @see FixedAction
 */

public class PreloadListAction extends FixedAction
{

    private Logger myLogger; // is the handle to LoggerAgent
    private MainPanel mainPanel;

    public PreloadListAction(ActionProcessor actpro,MainPanel mainPanel, Logger myLogger)
    {
        super("PreloadListActionIcon", "Edit preload list", actpro);
        this.myLogger = myLogger;
        this.mainPanel = mainPanel;
    }

    public void doAction()
    {
        String oldPreload = myLogger.getPreload();
        String newPreload = JOptionPane.showInputDialog(mainPanel,"Edit preload list",oldPreload);
        if (newPreload != null) {
            myLogger.setPreload(newPreload);
        }

    }

}
