package jadex.adapter.jade.tools.logger.gui;

import jadex.adapter.jade.tools.logger.Logger;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * User: Ruediger Leppin
 * Date: 22.12.2003
 * Time: 10:37:18
 */
public class PreloadPanel extends JPanel
{
    private static final String PRELOAD_TEXT = "Preload List:";

    private Logger myLogger;

    private JLabel label;
    private JTextField field;
    private Font font = new Font("Helvetica", Font.PLAIN, 12);

    public PreloadPanel(Logger logger)
    {
        this.myLogger = logger;

        Font f = new Font("SanSerif", Font.PLAIN, 14);
        setFont(f);
        setLayout(new BorderLayout(10, 10));

        field = new JTextField(myLogger.getPreload());
        field.setFont(font);
        field.setEditable(true);
        field.setRequestFocusEnabled(true);
        field.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                myLogger.setPreload(field.getText());
            }
        });
        field.addFocusListener(new FocusListener()
        {
            public void focusLost(FocusEvent e)
            {
                myLogger.setPreload(field.getText());
            }

            public void focusGained(FocusEvent e)
            {
            }
        });

        label = new JLabel(PRELOAD_TEXT);
        label.setFont(font);
        label.setLabelFor(field);

        add(label, BorderLayout.WEST);
        add(field);
    }

    public void setField(String string)
    {
        field.setText(string);
    }
}
