package jadex.adapter.jade.tools.logger.jadeexample;

import java.util.logging.*;
import jade.core.behaviours.TickerBehaviour;


/**
 *  Behaviour which resets periodically a belief.
 */
class BeliefResetBehaviour extends TickerBehaviour
{
 	//-------- attributes --------

    /** The log agent. */
	private LogAgent logagent;

	/** The logger. */
    private Logger logger;

 	//-------- constructors --------

	/**
	 *  Create a new behaviour.
	 *  @param logagent The log agent.
	 */
    public BeliefResetBehaviour(LogAgent logagent)
    {
        super(logagent, LogAgent.RESET_TIME);
        this.logagent = logagent;
        this.logger = logagent.getLogger();
    }

	//-------- methods --------

	/**
	 *  Reset the belief.
	 */
    protected void onTick()
    {
        // Reset belief
        logagent.data = 0;

        // Create a log message with level info
        logger.log(Level.INFO, "Belief reseted.");
    }
}
