/*****************************************************************
 JADE - Java Agent DEvelopment Framework is a framework to develop
 multi-agent systems in compliance with the FIPA specifications.
 Copyright (C) 2000 CSELT S.p.A.

 GNU Lesser General Public License

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation,
 version 2.1 of the License.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the
 Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 Boston, MA  02111-1307, USA.
 *****************************************************************/

package jadex.adapter.jade.tools.rma;

import java.awt.Frame;

import jade.gui.AgentTree;
import jade.BootHelper;
import jade.core.*;

import java.util.Vector;
import java.util.Enumeration;

import jade.util.leap.ArrayList;

/**

 @author Francisco Regi, Andrea Soracchi - Universita` di Parma
 @version $Date: 2005-04-26 13:45:51 +0000 (Tue, 26 Apr 2005) $ $Revision: 2556 $
 */
class StartNewAgentAction extends ContainerAction
{

	private rma myRMA;
	private Frame mainWnd;

	public StartNewAgentAction(rma anRMA, Frame f, ActionProcessor actPro)
	{
		super("StartNewAgentActionIcon", "Start New Agent", actPro);
		myRMA = anRMA;
		mainWnd = f;
	}

	public void doAction(AgentTree.ContainerNode node)
	{

		String containerName = node.getName();
		int result = doStartNewAgent(containerName);
	}

	private int doStartNewAgent(String containerName)
	{
		StartDialog.Result result = StartDialog.showDialog(mainWnd, containerName);
		if(result.choice == StartDialog.OK_BUTTON)
		{

			//MBDIAgent model = StartDialog.getAgentModel();
			String modelName = result.modelname;
			String configName = result.configname;
			String agentName = result.agentname;
			String className = result.classname;
			String container = result.container;
			String arguments = result.arguments;

			/* System.out.println("Model name: "+modelname);
			 System.out.println("Agent name: "+agentname);
			 System.out.println("Class name: "+classname);
			 System.out.println("Container: "+container);
			 System.out.println("Arguments: "+arguments);  */

			if ((agentName.trim().length() > 0) && (className.trim().length() > 0))
			{
				String agentSpecifier = agentName + ":" + className + "(" + arguments + ")";
				//not remove '"'and '\'
				BootHelper helperParser = new BootHelper();
				Vector al = helperParser.T2(agentSpecifier, true);

				ArrayList argList = new ArrayList();
				//return a list of lists in the form [[agentName1, class, arg1...argN]....[agentNameN, class, arg1, ...argM]]
				Enumeration it = helperParser.getCommandLineAgentSpecifiers(al);
				Object[] arg = (it.hasMoreElements() ? ((Specifier) it.nextElement()).getArgs() :
						new Object[0]);
				if (modelName.length() != 0)
				{
					//System.out.println("Starting Jadex Agent");
					Object[] arg2 = new Object[arg.length + 2];
					arg2[0] = modelName;
					arg2[1] = configName==null? "": configName;
					for (int i = 0; i < arg.length; i++)
						arg2[i + 2] = arg[i];
					myRMA.newAgent(agentName, className, arg2, container);
				}
				else
				{
					//System.out.println("Starting JADE Agent");
					myRMA.newAgent(agentName, className, arg, container);
				}
			}
		}
		return result.choice;
	}

}  // End of StartNewAgentAction









